#ifndef BisqBitBuf_h
#define BisqBitBuf_h

#include <vector>
#include <string>

#include "sizes.h"

class BitBuf
{
	static const unsigned bbmin = 2, bbbits = 3;
	static const unsigned oomin = 3, oobits = 2;
	static const unsigned ppmin = 5, ppbits = 2;
public:
	BitBuf() : alloced(0), bitcount(0) { }
	BitBuf(const string &s) : alloced(0), bitcount(0) { *this = s; }
	
	void Resize(unsigned newbitsize);
	void Clear();
	
	void Add(unsigned value, unsigned count);
    unsigned Read(unsigned count, unsigned bitpos) const;
	void Copy(BitBuf &src, unsigned srcbitpos, unsigned count);
	
	inline unsigned size() const { return bitcount; }

	void Compress();
	void Decompress();
	
	BitBuf &operator= (const string &s);
	
	operator std::string() const;
	
private:
	unsigned alloced;
	std::vector<BYTE> ptr;

	DWORD bitcount;
};

#endif
