#include "syntaxparser.hh"
#include "parser.hh"

#include <iostream>

#define COMPRESS_BITBUF     0
#define COMPRESS_DICTIONARY 0

#include "dictionary.hh"

static Syntax *syntaxparser;

static string fgetsstringtrans(const char *s)
{
	string q(s);
	for(;;)
	{
		unsigned b = q.find('\r');
		if(b == q.npos) { b = q.find('\n');
		if(b == q.npos) break; }
		q.erase(b);
	}
	return q;
}

static string Decompress(BitBuf s)
{
#if COMPRESS_BITBUF
	s.Decompress();
	return s;
#elif COMPRESS_DICTIONARY
	return DictDecompress(s);
#else
	return s;
#endif
}
static BitBuf Compress(const string &s)
{
#if COMPRESS_BITBUF
	BitBuf result = s;
	result.Compress();
	return result;
#elif COMPRESS_DICTIONARY
	BitBuf result = DictCompress(s);
	// cerr << "Compressed " << s.size()*8 << " bits to " << result.size() << " bits\n";
	return result;
#else
	return BitBuf(s);
#endif
}

void Load(const char *s)
{
	syntaxparser = new Syntax(s);
}

int Encoded(const char *s)
{
	const char *q = rivitunniste;
	while(*s && *q)
		if(*q++ != *s++)return 0;
	return *q ? 0 : 1;
}
int Decode(const char *s)
{
	cout << Decompress(syntaxparser->Decode(fgetsstringtrans(s + strlen(rivitunniste)))) << endl;
	return 0;
}
int Encode(const char *s)
{
	cout << rivitunniste << syntaxparser->Encode(Compress(fgetsstringtrans(s))) << endl;
	return 0;
}
void Unload()
{
	delete syntaxparser;
	syntaxparser = NULL;
}
